'**************************************************************************
'* PROG REMA5A.BAS   08/Feb/99  REMA FOR AUTOMATIC HOLDER / cubic option, *
'*                              read geol.file                            *
'**************************************************************************

DECLARE SUB Clearbuff ()
20 OPTION BASE 1
'------------------------------------------------------------------
DIM bfs(2, 2) AS STRING * 1
TYPE geol1                        ' 1st record in  XXX.GED
	num AS STRING * 4              ' Number of specimens in file plus 2
	namloc AS STRING * 16          ' literary name of locality
	long AS STRING * 7             ' geographical longitude of locality
	lat AS STRING * 7              ' geographical latitude of locality
	rock AS STRING * 4             ' rock type
	strat AS STRING * 4            ' stratigraphy
	lito AS STRING * 4             ' lithostratigraphy
	regi AS STRING * 4             ' regional geological position
	pr1 AS STRING * 3
	pr2 AS STRING * 3              ' pr1 to pr4 orientation parameters
	pr3 AS STRING * 3
	pr4 AS STRING * 3
	crlf AS STRING * 2
END TYPE
DIM geol1 AS geol1

TYPE geol                         ' any record in XXX.GED but 1st
	nam AS STRING * 12             ' name of specimen
	azim AS STRING * 4             ' first orientation angle
	plun AS STRING * 4             ' second orientation angle
	bfs11 AS STRING * 1            ' code of first meso foliation
	bfs21 AS STRING * 1            ' code of first meso lineation
	dum AS STRING * 2
	dfoli1 AS STRING * 4           ' azimuth of the first foliation
	ifoli1 AS STRING * 4           ' dip of the first foliation
	dline1 AS STRING * 4           ' trend of the first lineation
	iline1 AS STRING * 4           ' plunge of the first lineation
	bfs12 AS STRING * 1            ' code of second meso foliation
	bfs22 AS STRING * 1            ' code of second meso linetion
	dummy AS STRING * 2
	dfoli2 AS STRING * 4           ' azimuth of the  second foliation
	ifoli2 AS STRING * 4           ' dip of the second foliation
	dline2 AS STRING * 4           ' trend of the second lineation
	iline2 AS STRING * 4           ' plunge of the second lineation
	crlf AS STRING * 4
END TYPE
DIM geol AS geol

TYPE hetype                            ' 1st (header) record, in XXX.ran file
	nrec AS INTEGER
	nameloc AS STRING * 16
	longi AS STRING * 7
	lati AS STRING * 7
	rockt AS STRING * 4
	strati AS STRING * 4
	litos AS STRING * 4
	regio AS STRING * 4
	pp1 AS STRING * 3
	pp2  AS STRING * 3
	pp3 AS STRING * 3
	pp4  AS STRING * 3
	vypl AS STRING * 4
END TYPE
DIM he AS hetype

TYPE datype                            ' data record in XXX.ran file
	names AS STRING * 12
	gk AS SINGLE
	gn AS SINGLE
	kalg(1 TO 6) AS SINGLE
	bfs11 AS STRING * 1
	bfs21 AS STRING * 1
	irho1 AS INTEGER
	iamu1 AS INTEGER
	itau1 AS INTEGER
	isig1 AS INTEGER
	bfs12 AS STRING * 1
	bfs22 AS STRING * 1
	irho2 AS INTEGER
	iamu2 AS INTEGER
	itau2 AS INTEGER
	isig2 AS INTEGER
END TYPE
DIM da AS datype
'---------------------------------

25 GOSUB 7000 ' KEYS BLANCK+OFF
30 OPEN "I", #3, "REMA5.FAC": INPUT #3, IP1, IP2, IP3, IP4, SPORT: CLOSE #3: GOSUB 4290
35 SPORT$ = RIGHT$(STR$(SPORT), 1)
40 DIM T(12)
50 DIM R(3, 3), R1(3, 3), R2(3, 3), a(3, 3), b(3, 3), C(3, 3), P(3), D(3)
60 RM = 9999: FOR i = 1 TO 12: T(i) = 9999: NEXT i
70 '
80 CLS : KEY OFF
82 PRINT : PRINT "***  REMA5A  ver. 3.8  ***": PRINT
85 PRINT "The program REMA5A processes JR-5A spinner magnetometer measurement"
	PRINT "of remanent  magnetization of rock specimen using  automatic holder."
	PRINT "The geological data file can be optionally used to input field data."
87 PRINT
88 PRINT "Current communication port  : COM"; SPORT$
89 PRINT "For change edit the file REMA5.FAC": PRINT
90 DEG = 180 / 3.14159: PRNS = 0: RPT = 0: NRREP = 7: cub = 0: nonor = 0

	PRINT "Select mode :"
	PRINT "Holder operated automatically or manually [A/M] ?  <CR> --> A"
	auto$ = INPUT$(1): PRINT
	IF auto$ = CHR$(13) OR auto$ = "a" OR auto$ = "A" THEN auto$ = "A" ELSE auto$ = "M"
	IF auto$ = "A" THEN
		PRINT "--> Automatic holder mode selected."
	ELSE
		BEEP
		PRINT "--> Automatic holder operated manually mode selected."
	END IF
	PRINT
91 PRINT "Do you wish to measure cubic specimen [Y/N] ?      <CR> --> N "
	qr$ = INPUT$(1): PRINT
	IF qr$ = "y" OR qr$ = "Y" THEN
		cub = -1: BEEP
		PRINT "--> Measuring routine for automatic cubic holder is selected now."
		PRINT "    Proper position is arrow oriented diagonally  to the left-up."
		PRINT "    Do not care  the displayed  components  on  JR-5A  display."
		PRINT "    If you wish to measure cylinder specimen run program again."
	ELSE
		PRINT "--> Measuring routine for automatic cylinder holder is selected now."
		PRINT "    If you wish to measure cubic specimen run program  REMA5A again."
	END IF
		PRINT
		PRINT "--> Be sure the measuring MODE and specimen TYPE is set properly on JR-5A."
	PRINT

100 '
110 'START PROG
120 'INPUT "DATE  /mm-dd-yy/ ";V$ : DATE$=V$
130 INPUT "Enter name of REMA data output file - max. 8 chars "; nam$
140 IF LEN(nam$) < 1 OR LEN(nam$) > 8 THEN 130
											'-----------------
190 PRINT : PRINT "OUTPUT PATH  (drive:\dir1\dir2\...)  [CR]=current  ";
200 INPUT path$
202 IF LEN(path$) = 0 THEN 220
204 IF RIGHT$(path$, 1) <> "\" THEN path$ = path$ + "\"
220 FIL$ = path$ + nam$ + ".JRA"
225 ON ERROR GOTO 4500
230 OPEN "R", #2, FIL$, 66
235 ON ERROR GOTO 0
240 FOR REC% = 1 TO 1000
250 FIELD #2, 10 AS F1$, 8 AS F2$, 6 AS F3$, 6 AS F4$, 6 AS F5$, 4 AS F6$, 4 AS F7$, 4 AS F8$, 4 AS F9$, 4 AS F10$, 4 AS F11$, 6 AS F12$
260 GET #2, REC%
270 IF F1$ = STRING$(10, 0) THEN 300
280 NEXT REC%
290 PRINT "*****  DISK ERROR": CLOSE : END
300 REC% = REC% - 1
310 IF REC% = 0 THEN 401            '------
320 PRINT CHR$(10): PRINT "=> FILE               "; FIL$; " already exist"
330 PRINT : PRINT "SUPPLEMENT TO FILE    "; FIL$; "  [Y/N] ? ";
340 Q$ = INPUT$(1)
350 IF Q$ = "Y" OR Q$ = "y" THEN 401             '----------
360 IF Q$ = "N" OR Q$ = "n" THEN 370 ELSE 340
370 CLOSE #2: PRINT : PRINT
400 GOTO 130
'---------------------------------------------
401 geoldata = 0
	 GOSUB selway
	 PRINT
410 PRINT "--> File : "; FIL$; TAB(25); " ready for output"
	 IF geoldata THEN PRINT "--> File : "; ownname$ + ".GED"; TAB(25); " ready for input"
405 PRINT : PRINT : PRINT "=> POWER ON the JR-5A if necessary": BEEP
420 PRINT : PRINT "   Press any key to continue ": Q$ = INPUT$(1)
'-------------------------------------------------------------
430 GOTO 3010
440 '
450 '
460 'SUBR SPEC
465 GOSUB 8000 ' KEYS OFF
470 RM = 9999: FOR i = 1 TO 12: T(i) = 9999: NEXT i
480 CLS : CYC = 0
482 PRINT "*** Automatic holder measurement routine   ": PRINT
484 IF RPTS = 1 THEN
		 PRINT "-->  To finish repetition in current position press ESC key"
		 PRINT "     otherwise the measurement is repeated" + STR$(NRREP) + " times."
	 END IF
486 PRINT : PRINT "Enter data :"
490 PRINT "SPECIMEN  - max.10 chars: "; SPEC$: INPUT QQ$
492 IF QQ$ <> "" THEN
		 SPEC$ = QQ$
		 namk$ = QQ$
	 END IF
500 IF LEN(SPEC$) < 1 OR LEN(SPEC$) > 10 THEN 490
510 PRINT "DEMAGNETIZATION - max. 8 chars: "; DEM$: INPUT QQQ$
	  IF QQQ$ <> "" THEN DEM$ = QQQ$
520 IF LEN(DEM$) > 8 THEN 510

findfl = 0                                '----------------
IF mgn = 1 THEN GOSUB searchgd
IF mgn > 1 OR findfl = 1 THEN             '**** block if
	 IF mgn = 3 OR nonor THEN GOTO 690
530 INPUT "SAMPLING ANGLES - azimuth,  dip"; IPFIA, IPSIA
540 IPFI = IPFIA: IPSI = IPSIA
600 IRHOA = 0: : IRHO = 0: IMU = 0: ITAUA = 0: ITAU = 0: ISIG = 0
	 IF nonor THEN tec$ = "N"
	 IF nonor THEN GOTO 690
610 PRINT "TECTONIC ANGLES  [Y/N] ? ";
620 tec$ = INPUT$(1): tec$ = UCASE$(tec$)
630 IF tec$ = "Y" THEN 650
640 IF tec$ = "N" THEN 690 ELSE 620
650 PRINT : INPUT "ENTER TECTONIC ANGLES - azimuth , dip , trend , plunge "; IRHOA, IMU, ITAUA, ISIG
690 PRINT : PRINT "KILL DATA  [Y/N] ?"; : Q$ = INPUT$(1): PRINT
700 IF Q$ = "Y" OR Q$ = "y" THEN 470
	 IRHO = IRHOA: ITAU = ITAUA
	 GOSUB coran                      '-----------------
710 CLS
END IF                                    ' end block if

720 GOSUB 1200 ' DISP HEADER
725 GOSUB 9000 ' KEYS ON
730 RETURN
740 '
750 ' SUBR END MEAS
760 GOSUB 1790 ' DISP AVER
770 XV = X: YV = Y: ZV = Z
780 GOSUB 1940 ' DECL
790 DECLS = DECL: INCLS = INCL
810 X1 = X: X2 = Y: X3 = Z
820 C1 = COS(F1): C2 = COS(F2): C3 = COS(F3)
830 S1 = SIN(F1): S2 = SIN(F2): S3 = SIN(F3)
840 XG = X1 * (C1 * C2 * C3 - S1 * S3) + X2 * (-C1 * C2 * S3 - S1 * C3) + X3 * (-C1 * S2)
850 YG = X1 * (S1 * C2 * C3 + C1 * S3) + X2 * (-S1 * C2 * S3 + C1 * C3) + X3 * (-S1 * S2)
860 ZG = X1 * (S2 * C3) + X2 * (-S2 * S3) + X3 * C2
870 XV = XG: YV = YG: ZV = ZG
880 GOSUB 1940 ' DECL
890 DECLG = DECL: INCLG = INCL
900 IF tec$ = "Y" THEN 910 ELSE 935
910 GOSUB 2370 ' PALEO
920 XV = XP: YV = YP: ZV = ZP: GOSUB 1940' DECL
930 DECLP = DECL: INCLP = INCL
935 GOSUB 2020 ' DISP RESULT
940 RETURN
950 '
960 ' SUBR WRITE FILE
970 PRINT #2, USING "\        \"; SPEC$;
980 PRINT #2, USING "\      \"; DEM$;
990 PRINT #2, USING "###.##"; INT(X * 100 + .5) / 100;
992 PRINT #2, USING "###.##"; INT(Y * 100 + .5) / 100;
994 PRINT #2, USING "###.##"; INT(Z * 100 + .5) / 100;
1020 PRINT #2, USING "####"; RM; IPFIA; IPSIA; IRHOA; IMU; ITAUA; ISIG;  '------
1050 PRINT #2, CHR$(13) + CHR$(10);
1060 REC% = REC% + 1
1070 PUT #2, REC%: CLOSE #2: OPEN "R", #2, FIL$, 66
1080 FIELD #2, 10 AS F1$, 8 AS F2$, 6 AS F3$, 6 AS F4$, 6 AS F5$, 4 AS F6$, 4 AS F7$, 4 AS F8$, 4 AS F9$, 4 AS F10$, 4 AS F11$, 6 AS F12$
1090 RETURN
1100 '
1110 'SUBR PRINTOUT
1115 LPRINT : LPRINT : LPRINT : LPRINT
1120 GOSUB 2090 ' PRINT HEADER
1130 FOR P = 1 TO 6: GOSUB 2190: NEXT P ' PRINT DATA
1140 GOSUB 2290 'PRINT AVER
1150 GOSUB 2910 ' PRINT RESULTS
1157 PRNS = PRNS + 1
1159 IF (PRNS MOD 2 = 0) THEN LPRINT CHR$(12);
1160 RETURN
1170 '
1180 '
1190 '
1200 'SUBR DISP HEADER
	  LOCATE 2, 1: FOR i = 1 TO 20: PRINT SPACE$(79): NEXT i
	  LOCATE 2, 1
	  IF RPTS = 1 THEN PRINT "--> Press ESC key to finish repetition"
1210 LOCATE 4, 1
1220 PRINT nam$; " / "; SPEC$; " / "; DEM$; TAB(34); : PRINT DATE$
1230 PRINT "-------------------------------------------"
1240 PRINT USING "SPEC.ANGLES                      ####  ####"; IPFIA; IPSIA
1250 IF tec$ = "Y" THEN PRINT USING "TECT.ANGLES          ####  ####  ####  ####"; IRHOA; IMU; ITAUA; ISIG
1260 PRINT "-------------------------------------------"
1270 PRINT "           M(x)       M(y)       M(z)"
1280 PRINT "-------------------------------------------"
1290 RETURN
1300 '
1310 ' SUBR DISP DATA
1320 LOCATE 10 + P, 1
1330 ON P GOTO 1340, 1360, 1380
1340 PRINT USING "#     ######.##             ######.##"; P; T(2 * P - 1); T(2 * P)
1350 GOTO 1390
1360 IF cub THEN
		  T1o = T(1): T3o = T(3)
		  T1n = .707 * (T1o + T3o): T3n = .707 * (-T1o + T3o)
		  PRINT USING "#                ######.##  ######.##"; P; T3n; T(2 * P)
		  LOCATE 9 + P, 1
		  PRINT USING "#     ######.##             ######.##"; 1; T1n; T(2)
	  ELSE
		  PRINT USING "#                ######.##  ######.##"; P; T(2 * P - 1); T(2 * P)
	  END IF
1370 GOTO 1390
1380 IF cub THEN
		  T5o = T(5): T6o = T(6)
		  T5n = .707 * (T5o + T6o): T6n = .707 * (-T5o + T6o)
		  PRINT USING "#     ######.##  ######.##           "; P; T5n; T6n
	 ELSE
		  PRINT USING "#     ######.##  ######.##           "; P; T(2 * P - 1); T(2 * P)
	 END IF
1390 RETURN
1400 '
1410 ' SUBR TEST DATA
1420 GOSUB 1730 ' meas.complete ?
1430 IF CYC <> 3 THEN RETURN
1440 Z = (T(2) + T(4)) / 2
1460 X = (T(1) + T(5)) / 2: Xo = X
1470 Y = (T(3) + T(6)) / 2: Yo = Y
	  IF cub THEN
		  X = (Xo + Yo) * .707
		  Y = (-Xo + Yo) * .707
	  END IF
1540 R1 = SQR(X * X + Y * Y + Z * Z)
1550 T = T(1) - Xo: w = T * T
1560 T = T(2) - Z: w = w + T * T
1570 T = T(3) - Yo: w = w + T * T
1580 T = T(4) - Z: w = w + T * T
1590 T = T(5) - Xo: w = w + T * T
1600 T = T(6) - Yo: w = w + T * T
1690 R2 = SQR(w / 6)
	  IF R1 = 0 THEN R1 = 1E-12
1700 R2 = 100 * R2 / R1: RGF = 7
1710 RETURN
1720 '
1730 FOR i = 1 TO 12: IF T(i) = 9999 THEN 1750
1740 NEXT i
1750 IF i > 6 THEN CYC = 3
1770 RETURN
1780 '
1790 ' SUBR DISP AVER
1800 LOCATE 14, 1
1810 PRINT "-------------------------------------------"
1820 PRINT USING "MEAN   #####.###  #####.###  #####.###"; X; Y; Z
1822 PRINT "MODULUS   "; : PRINT USING "##.###^^^^"; R1 * 10 ^ RM; : PRINT " ["; UN$; "]  PRECISION";
1824 PRINT USING "##.#"; R2; : PRINT " %"
1840 RETURN
1850 '
1860 REM SUBR  ATN2=ATN(YY,XX)
1870 IF xx <> 0 THEN 1890
1880 ATN2 = 90 * SGN(.5 + SGN(YY)): RETURN
1890 ATN2 = DEG * ATN(YY / xx)
1900 IF xx > 0 THEN 1920
1910 ATN2 = ATN2 + 180 * SGN(.5 + SGN(YY))
1920 RETURN
1930 '
1940 ' SUBR DECL (XV,YV,ZV,DECL,INCL)
1950 YY = YV: xx = XV: GOSUB 1870' ATN2
1960 DECL = ATN2
1970 IF DECL < 0 THEN DECL = DECL + 360
1980 YY = ZV: xx = SQR(XV ^ 2 + YV ^ 2): GOSUB 1870' ATN2
1990 INCL = ATN2
2000 RETURN
2010 '
2020 ' SUBR DISP RESULT
2027 PRINT "-------------------------------------------"
2050 PRINT USING "SPEC.S. (Dec,Inc)   #######    #######"; DECLS; INCLS
2055 IF IPFIA = 0 AND IPSIA = 0 THEN 2063
2060 PRINT USING "GEOGR.S.            #######    #######"; DECLG; INCLG
2063 IF tec$ = "Y" THEN 2065 ELSE 2070
2065 PRINT USING "PALEO.S.            #######    #######"; DECLP; INCLP
2070 RETURN
2080 '
2090 ' SUBR PRINT HEADER
2100 LPRINT nam$; " / "; SPEC$; " / "; DEM$; TAB(34); : LPRINT DATE$
2110 LPRINT "-------------------------------------------"
2120 LPRINT USING "SPEC.ANGLES                      ####  ####"; IPFIA; IPSIA
2130 IF tec$ = "Y" THEN LPRINT USING "TECT.ANGLES          ####  ####  ####  ####"; IRHOA; IMU; ITAUA; ISIG
2140 LPRINT "-------------------------------------------"
2150 LPRINT USING "E###"; RM; : LPRINT "       M(x)       M(y)       M(z)"
2160 LPRINT "-------------------------------------------": LPRINT
2170 RETURN
2180 '
2190 ' SUBR PRINT DATA
2200 IF T(2 * P) = 9999 THEN RETURN
	  IF cub THEN
		  T(1) = T1n: T(3) = T3n
		  T(5) = T5n: T(6) = T6n
	  END IF
2210 ON P GOTO 2220, 2240, 2260
2220 LPRINT USING "#     ######.##             ######.##"; P; T(2 * P - 1); T(2 * P)
2230 GOTO 2270
2240 LPRINT USING "#                ######.##  ######.##"; P; T(2 * P - 1); T(2 * P)
2250 GOTO 2270
2260 LPRINT USING "#     ######.##  ######.##           "; P; T(2 * P - 1); T(2 * P)
2270 RETURN
2280 '
2290 ' SUBR PRINT AVER
2300 LPRINT "-------------------------------------------"
2310 LPRINT USING "MEAN   #####.###  #####.###  #####.###"; X; Y; Z
2320 LPRINT : LPRINT "MODULUS   "; : LPRINT USING "##.###^^^^"; R1 * 10 ^ RM; : LPRINT " "; UN$; "    PRECISION";
2330 LPRINT USING "##.#"; R2; : LPRINT " %"
2340 LPRINT "-------------------------------------------"
2350 RETURN
2360 '
2370 ' SUB PALEO
2380 REM
2390 GOSUB 2690 ' ROTPL
2400 b(1, 1) = XG: b(2, 1) = YG: b(3, 1) = ZG
2410 FOR i = 1 TO 3: FOR J = 1 TO 3: a(i, J) = R(i, J): NEXT J: NEXT i
2420 L = 3: m = 3: N = 1: GOSUB 2470'MXMP11
2430 XP = C(1, 1): YP = C(2, 1): ZP = C(3, 1)
2440 RETURN
2450 REM
2460 '
2470 ' SUBR MXMP11
2480 FOR i = 1 TO L
2490 FOR K = 1 TO N
2500 S = 0
2510 FOR J = 1 TO m
2520 S = S + a(i, J) * b(J, K)
2530 NEXT J
2540 C(i, K) = S
2550 NEXT K
2560 NEXT i
2570 RETURN
2580 '
2590 ' SUBR ROTAR
2600 T = OMEGA / DEG: S = SIN(T): C1 = 1 - COS(T)
2610 FOR i = 1 TO 3
2620 J = i MOD 3: J = J + 1: K = J MOD 3: K = K + 1
2630 R(i, K) = D(i) * D(K) * C1 + D(J) * S
2640 R(J, K) = D(J) * D(K) * C1 - D(i) * S
2650 R(K, K) = 1 - (1 - D(K) * D(K)) * C1
2660 NEXT i
2670 RETURN
2680 '
2690 ' SUBR ROTPL
2700 T = IRHO / DEG: D(1) = -SIN(T): D(2) = COS(T): D(3) = 0
2710 OMEGA = IMU
2720 IF ISIG = 0 THEN 2880
2730 GOSUB 2590 ' ROTAR
2740 FOR i = 1 TO 3: FOR J = 1 TO 3: a(i, J) = R(i, J): R2(i, J) = R(i, J): NEXT J: NEXT i
2750 T = ITAU / DEG: COST = COS(T): SINT = SIN(T)
2760 T = ISIG / DEG: COSS = COS(T): SINS = SIN(T)
2770 b(1, 1) = COST * COSS: b(2, 1) = SINT * COSS: b(3, 1) = SINS
2780 L = 3: m = 3: N = 1: GOSUB 2470'MXMP11
2790 YY = C(2, 1): xx = C(1, 1)
2800 GOSUB 1860 ' ATN2
2810 OMEGA = ITAU - ATN2: D(1) = 0: D(2) = 0: D(3) = 1: GOSUB 2590' ROTAR
2820 FOR i = 1 TO 3: FOR J = 1 TO 3
2830 a(i, J) = R(i, J): b(i, J) = R2(i, J)
2840 NEXT J: NEXT i
2850 N = 3: GOSUB 2470' MXMP11
2860 FOR i = 1 TO 3: FOR J = 1 TO 3: R(i, J) = C(i, J): NEXT J: NEXT i
2870 RETURN
2880 GOSUB 2590
2890 RETURN
2900 '
2910 ' SUBR PRINT RESULTS
2920 LPRINT USING "O.P: ## ## ## ##     DECL        INCL"; IP1; IP2; IP3; IP4
2930 LPRINT "-------------------------------------------"
2940 LPRINT USING "SPEC. S.             ####        ####"; DECLS; INCLS
2945 IF IPFIA = 0 AND IPSIA = 0 THEN 2960
2950 LPRINT USING "GEOGR.S.             ####        ####"; DECLG; INCLG
2960 IF tec$ = "N" THEN 2980
2970 LPRINT USING "PALEO.S.             ####        ####"; DECLP; INCLP
2980 LPRINT "-------------------------------------------": LPRINT : LPRINT : LPRINT
2990 LPRINT : LPRINT : LPRINT : LPRINT
3000 RETURN
3010 OPEN "COM" + SPORT$ + ":4800,O,7,2,cs,ds" FOR RANDOM AS #1: GOSUB 9010
Clearbuff
PRINT #1, "R";
star = TIMER
w$ = ""
DO
	IF LOC(1) > 0 THEN
		w1$ = INPUT$(1, #1)
		w$ = w$ + w1$
		IF w1$ = CHR$(10) THEN EXIT DO
	END IF
	wt = TIMER - star
	IF wt > 10 THEN
		CLOSE
		CLS
		PRINT "####  RS-232  COMMUNICATION  ERROR"
		PRINT w$
		GOSUB bbb
		PRINT "Current communication  port : COM" + SPORT$
		PRINT "For change edit the file REMA5.FAC"
		CLOSE
		PRINT
		PRINT "Switch off and on JR-5A and run REMA5A program again"
		PRINT : PRINT "Press any key to abort program "
		sss$ = INPUT$(1)
		GOTO ex
	END IF
LOOP WHILE -1


3020 KEY ON
3030 ON COM(SPORT) GOSUB 3982: COM(SPORT) ON
3040 CLS : GOSUB 3190 'REMOTE
3050 RGF = 0: RPT = 0
3060 KEY 1, "REMOTE": ON KEY(1) GOSUB 3190: KEY(1) ON
3070 KEY 2, "  C/C ": ON KEY(2) GOSUB 3220: KEY(2) ON
3080 KEY 3, "REPEAT": ON KEY(3) GOSUB 3260: KEY(3) ON
3090 KEY 4, " MEAS ": ON KEY(4) GOSUB 3270: KEY(4) ON
3100 KEY 5, " AUTO ": ON KEY(5) GOSUB 3650: KEY(5) ON
3110 KEY 6, " RANGE": ON KEY(6) GOSUB 3680: KEY(6) ON
3120 KEY 7, " LOCAL": ON KEY(7) GOSUB 3890: KEY(7) ON
3130 KEY 8, " HELP ": ON KEY(8) GOSUB 5000: KEY(8) ON
3140 KEY 9, " STOP ": ON KEY(9) GOSUB 3950: KEY(9) ON
3145 KEY 10, " QUIT ": ON KEY(10) GOSUB 3912: KEY(10) ON
3150 KEY 16, CHR$(0) + CHR$(1): KEY 17, CHR$(32) + CHR$(1)
3152 KEY 18, CHR$(64) + CHR$(1): KEY 19, CHR$(96) + CHR$(1)
3154 ON KEY(16) GOSUB 5500: ON KEY(17) GOSUB 5500
3156 ON KEY(18) GOSUB 5500: ON KEY(19) GOSUB 5500
3158 KEY(16) ON: KEY(17) ON: KEY(18) ON: KEY(19) ON
3159 IF RPT = NRREP AND RPTF <> 999 THEN GOSUB 5500
3160 IF RGF = 1 THEN 3050 ELSE 3159
3170 END
3180 '
3190 REM REMOTE
3200 PRINT #1, "R";
	  RETURN
3210 '

3220 REM CALIB
3230 'T(1)=2.47 : T(2)=-9.79 : T(3)=4.23 : T(4)=-9.72 : T(5)=-4.77 : T(6)=10.19      :T(7)=-2.88: T(8)=10.24 : T(9)=-4.64 : T(10)=10.66 : T(11)=2.36: T(12)=-9.41
3240 'RM= -3 : RETURN
IF auto$ = "M" THEN
32451 IF CORRFL = 0 THEN PRINT #1, "F";  'set position Nr.1    '&&&&&
END IF
3250 PRINT #1, "C";
	  RETURN

3255 '
3260 'MEAS ROUTINE WITH REPEATITION
3267 RPTS = 1: RPTF = 0
3270 REM AUTO MEAS ROUTINE
3272 IF CORRFL <> 0 THEN 3492                  '@@@@@@@@
3275 IF REMOTE = 0 THEN GOSUB 3190'REMOTE
3280 GOSUB 460 ' SPEC
IF auto$ = "M" THEN
32901 KEY 1, "  P 1 ": ON KEY(1) GOSUB 34001                  '&&&&&&&
33001 KEY 2, "  P 2 ": ON KEY(2) GOSUB 34101
33101 KEY 3, "  P 3 ": ON KEY(3) GOSUB 34201
ELSE
3290 KEY 1, " EXEC ": ON KEY(1) GOSUB 3465
3300 KEY 2, "      ": KEY(2) OFF
3310 KEY 3, "      ": KEY(3) OFF
END IF
3320 KEY 4, "      ": KEY(4) OFF
3330 KEY 5, "      ": KEY(5) OFF
3340 KEY 6, "      ": KEY(6) OFF
3350 KEY 7, " QUIT ": ON KEY(7) GOSUB 3540
3360 KEY 8, "QPRINT": ON KEY(8) GOSUB 3605: KEY(8) ON
3370 KEY 9, " STOP ": ON KEY(9) GOSUB 3950: KEY(9) ON
3380 KEY 10, " KILL ": ON KEY(10) GOSUB 3510: KEY(10) ON
3390 RETURN

34001 P = 1: GOTO 3465                  '&&&&&&&&
34101 P = 2: GOTO 34801
34201 P = 3: GOTO 34801

3460 '
3465 'START AUTO HOLDER MEASUREMENT          '@@@@@@
IF auto$ = "M" THEN
34661 IF RPTS = 1 THEN GOSUB 5800
34671 IF RPTS = 1 THEN PRINT #1, CHR$(64);
34701 PRINT #1, RIGHT$(STR$(P), 1); : LOCATE 1, 52: PRINT "--> P"; RIGHT$(STR$(P), 1); " IS RUNNING <--    ": RETURN
34801 IF RM <> 9999 THEN 34661
34901 LOCATE 1, 52: BEEP: PRINT "###  START POSITION Nr.1 "
		RETURN
ELSE
3466 IF RPTS = 1 THEN GOSUB 5800
3467 IF RPTS = 1 THEN PRINT #1, CHR$(64);
3470 PRINT #1, "E";
3472 IF RPTS = 1 THEN 3480
3474 LOCATE 1, 52: PRINT "-->  AUTO HOLDER  <--   "
3480 RETURN
END IF
3492 LOCATE 1, 1: BEEP: PRINT "WARNING : CORRECTION ISN'T COMPLETE !"
	  RETURN
3500 '
3510 ' KILL MEAS / QUIT RANGE
3515 CLS : GOSUB 3950 'STOP - for the case the motor is on
3520 RGF = 1: RPT = 0: RPTS = 0: RETURN
3530 '
3540 ' FINISH MEAS - QIUT MEAS ROUTINE
3550 IF RGF = 7 THEN 3570
3560 LOCATE 1, 52: BEEP: PRINT "###  MISSING POSITION !   ": RETURN
3570 GOSUB 960' WRITE FILE
3580 RGF = 1: RPTS = 0: RPT = 0
3590 RETURN
3600 '
3605 'PRINT RESULT ON PRINTER - QUIT MEAS ROUTINE
3610 IF RGF <> 7 THEN 3560
3620 GOSUB 1110 ' PRINTOUT
3630 GOTO 3570
3640 '
3650 REM AUTO
3660 PRINT #1, "A"; : RETURN
3670 '
3680 REM RANGE
3690 KEY 1, " E-4 L": ON KEY(1) GOSUB 3800
3700 KEY 2, " E-4  ": ON KEY(2) GOSUB 3810
3710 KEY 3, " E-3  ": ON KEY(3) GOSUB 3820
3720 KEY 4, " E-2  ": ON KEY(4) GOSUB 3830
3730 KEY 5, " E-1  ": ON KEY(5) GOSUB 3840
3740 KEY 6, " E+0  ": ON KEY(6) GOSUB 3850
3750 KEY 7, " E+1  ": ON KEY(7) GOSUB 3860
3760 KEY 8, " E+2  ": ON KEY(8) GOSUB 3870: KEY(8) ON
3770 KEY 9, "      ": KEY(9) OFF
3775 KEY 10, " QUIT ": ON KEY(10) GOSUB 3520: KEY(10) ON
3780 RETURN
3790 '
3800 PRINT #1, "I"; : RGF = 1: RETURN
3810 PRINT #1, "J"; : RGF = 1: RETURN
3820 PRINT #1, "K"; : RGF = 1: RETURN
3830 PRINT #1, "L"; : RGF = 1: RETURN
3840 PRINT #1, "M"; : RGF = 1: RETURN
3850 PRINT #1, "N"; : RGF = 1: RETURN
3860 PRINT #1, "O"; : RGF = 1: RETURN
3870 PRINT #1, "P"; : RGF = 1: RETURN
3880 '
3890 REM LOCAL
3900 PRINT #1, "Q"; : RETURN
3901 '
3912 REM QUIT PROGRAM
3915 KEY OFF: COM(SPORT) OFF: CLS : LOCATE 3, 1: GOSUB 3950: INPUT #1, a$ '@@@@
3920 GOSUB 3890: INPUT #1, a$: PRINT a$
3925 IF (PRNS MOD 2 = 1) THEN LPRINT CHR$(12);
3930 CLOSE : PRINT "Program terminated": END
3940 '
3950 REM STOP
3960 PRINT #1, "S"; : RPT = 0: RETURN
3970 '
3980 ' READ MESSAGE
3982 COM(SPORT) OFF
3984 GOSUB receive                                 ' a$ = INPUT$(27, #1)
3986 IF MID$(a$, 4, 6) = "REPEAT" THEN GOSUB 5900
3987 IF RPT = 0 THEN LIN = 1 ELSE LIN = LIN + 1        '@@@@@@
3988 GOSUB 9050
3989 IF LIN = 22 THEN LIN = 1
3991 LOCATE LIN, 52: PRINT a$
3992 IF MID$(a$, 4, 5) = "LOCAL" THEN REMOTE = 0
3993 IF MID$(a$, 4, 6) = "REPEAT" THEN LIN = LIN - 1
3994 IF MID$(a$, 4, 6) = "REMOTE" THEN REMOTE = 1
4000 IF (LEFT$(a$, 1) = "P") AND (MID$(a$, 4, 8) <> "OVERFLOW") THEN 4020
4005 COM(SPORT) ON
4010 RETURN
4020 IF MID$(a$, 5, 1) = " " THEN MID$(a$, 5, 1) = "0"
4030 IF MID$(a$, 6, 1) = " " THEN MID$(a$, 6, 1) = "0"
4040 IF MID$(a$, 13, 1) = " " THEN MID$(a$, 13, 1) = "0"
4050 IF MID$(a$, 19, 1) = " " THEN MID$(a$, 19, 1) = "+"
4060 P = VAL(MID$(a$, 2, 1)): UN$ = MID$(a$, 23, 3)
4070 T(2 * P - 1) = VAL(MID$(a$, 4, 6)): T(2 * P) = VAL(MID$(a$, 11, 6)): RC = VAL(MID$(a$, 19, 3))
4080 IF P = 1 THEN RM = RC
4090 IF RM < RC THEN GOTO 4180
4100 LOCATE 8, 1
	  IF tec$ = "Y" THEN LOCATE 9, 1
4110 IF P = 1 THEN PRINT MID$(a$, 18, 8);
4120 FAK = 10 ^ (RC - RM): T(2 * P - 1) = T(2 * P - 1) * FAK: T(2 * P) = T(2 * P) * FAK
4125 IF RPT <> 0 THEN GOSUB 5700
4130 GOSUB 1310 'DISP DATA
4140 GOSUB 1410 ' TEST DATA
4150 IF RGF = 7 THEN GOSUB 750' END MEAS
4155 COM(SPORT) ON
4160 RETURN
4170 '
4180 ' OPRAV
4190 FAK = 10 ^ (RM - RC): RM = RC: PS = P
4200 FOR P = 1 TO 6
4210 IF P = PS THEN 4250
4220 IF T(2 * P) = 9999 THEN 4250
4230 T(2 * P - 1) = T(2 * P - 1) * FAK: T(2 * P) = T(2 * P) * FAK
4240 GOSUB 1310 ' DISP DATA
4250 NEXT P
4260 LOCATE 8, 1: IF tec$ = "Y" THEN LOCATE 9, 1
4270 PRINT MID$(a$, 18, 8);
4280 P = PS: GOTO 4125
4290 'PARAMETR TEST
	  pr(1) = IP1: pr(2) = IP2: pr(3) = IP3: pr(4) = IP4
4300 Z(1) = IP1: Z(2) = IP2: Z(3) = IP3: Z(4) = IP4
4310 FOR i = 1 TO 4
4320 IF i = 1 OR i = 3 THEN 4350
4330 IF Z(i) = 0 OR Z(i) = 90 THEN 4360
4340 PRINT "INVALID PARAMETER "; i; " !!": BEEP: PRINT "MODIFY FILE  : REMA5.FAC": END
4350 IF Z(i) = 3 OR Z(i) = 6 OR Z(i) = 9 OR Z(i) = 12 THEN 4360 ELSE 4340
4360 NEXT i
4370 RETURN
4500 PRINT "Invalid path ! ": BEEP: RESUME 190
4999 '
5000 CLS
5002 PRINT "		        M A I N   M E N U    "
5003 PRINT "------------------------------------------------------------------"
5004 PRINT "REMOTE      set instrument to remote mode"
5006 PRINT "C/C         calibration or correction"
5008 PRINT "REPEAT      automatic measurement routine with repetition"
5010 PRINT "MEAS        automatic measurement routine"
5012 PRINT "AUTO        set instrument to auto range mode"
5014 PRINT "RANGE       set manual range"
5016 PRINT "LOCAL       set instrument to local mode"
5020 PRINT "STOP        stop measurement"
5022 PRINT "QUIT        quit program"
5024 PRINT "------------------------------------------------------------------"
5026 PRINT "               R E P E A T  and  M E A S  submenu  "
5028 PRINT "------------------------------------------------------------------"

IF auto$ = "M" THEN
50301 PRINT "P1 P2 P3    start measurement in current position"     '&&&&&&&
ELSE
5030 PRINT "EXEC        execute automatic measurement routine"
END IF
5032 PRINT "QUIT        quit measurement routine, return to main menu"
5034 PRINT "QPRINT      quit measurement, print results on printer"
5036 PRINT "KILL        cancel measurement, return to main manu"
5038 PRINT "------------------------------------------------------------------"
5040 PRINT "                    R A N G E  submenu  "
5042 PRINT "------------------------------------------------------------------"
5044 PRINT "E-4 .. E+2  set manual range from E-4 to E+2 A/m"
5200 RETURN
5201 '
5500 'exit repeat mode
5502 PRINT #1, "X"; : RPTF = 999
5504 RETURN
5540 '
5700 a1(RPT) = T(2 * P - 1): A2(RPT) = T(2 * P): RPT = RPT + 1
5702 IF RPT < 4 THEN 5727
5710 IF RPT < 5 THEN M1 = 1 ELSE M1 = RPT - 3
5716 AS1 = 0: AS2 = 0: FOR i = M1 TO RPT - 1: AS1 = AS1 + a1(i): AS2 = AS2 + A2(i): NEXT i
5724 T(2 * P - 1) = AS1 / (RPT - M1): T(2 * P) = AS2 / (RPT - M1)
5727 IF RPTF = 999 OR RPT = 11 THEN 5728 ELSE 5790
5728 RPT = 1: RPTF = 0
5790 RETURN
5800 FOR i = 1 TO 21: LOCATE i, 52: PRINT "                         "; : NEXT i
5802 RETURN
5900 RPT = 1: LIN = 0: RETURN
7000 FOR i = 1 TO 10: KEY i, "": KEY(i) OFF: NEXT i: RETURN
8000 FOR i = 1 TO 10: KEY(i) OFF: NEXT i: KEY OFF: RETURN
9000 FOR i = 1 TO 10: KEY(i) ON: NEXT i: KEY ON: RETURN
9010 FOR i = 1 TO 1000: xx = RND: NEXT i
9011 IF LOC(1) = 0 THEN RETURN
9012 dum$ = INPUT$(1, #1): GOTO 9011

9050 IF MID$(a$, 1, 2) = "H1" THEN CORRFL = 1          '@@@@@@@
9060 IF MID$(a$, 1, 2) = "H3" THEN GOSUB 9100
9070 LINAX = VAL(MID$(a$, 2, 1))
9080 IF MID$(a$, 1, 1) = "H" THEN LIN = LIN + LINAX
9090 RETURN
9100 CORRFL = 0
9110 LOCATE 1, 1: PRINT SPACE$(40);
9120 RETURN

'------------------------------------------------------------

selway:
'  *** Three-way decision
PRINT : PRINT
PRINT "Select way how to input data : ?  "
PRINT "Using geological file         [1] "
PRINT "Manual input from memo-book   [2] "
PRINT "Non-oriented specimen         [3] "
LOCATE CSRLIN - 4, 32
DO
w$ = INKEY$
LOOP UNTIL w$ = "1" OR w$ = "2" OR w$ = "3"
PRINT w$
mgn = VAL(w$)
PRINT : PRINT : PRINT : PRINT

SELECT CASE mgn
CASE 1

	INPUT "Enter name of GEO data input file - max. 8 chars "; ownname$
	fullname$ = path$ + ownname$
	
	CLOSE (10)
	OPEN fullname$ + ".GED" FOR RANDOM AS #10 LEN = 64
	IF LOF(10) = 0 THEN
		CLOSE (10)
		KILL fullname$ + ".GED"
		PRINT
		PRINT "Geological data file  "; ownname$ + ".GED"; "  not found !"
		PRINT
		GOSUB bbb
		PRINT "Press any key to abort program "
		qaz$ = INPUT$(1)
		GOTO ex
	ELSE
		GET #10, 1, geol1
		he.nameloc = geol1.namloc
		he.longi = geol1.long
		he.lati = geol1.lat
		he.rockt = geol1.rock
		he.strati = geol1.strat
		he.litos = geol1.lito
		he.regio = geol1.regi
		prg(1) = VAL(geol1.pr1)
		prg(2) = VAL(geol1.pr2)
		prg(3) = VAL(geol1.pr3)
		prg(4) = VAL(geol1.pr4)
	END IF
	IF IP1 + IP2 + IP3 + IP4 = 0 THEN GOTO ex
	FOR i = 1 TO 4
		 IF pr(i) <> prg(i) THEN
			PRINT "W A R N I N G  ! "
			PRINT
			PRINT "Orientation parameters in geological file and configuration file are different"
			PRINT
			GOSUB bbb
			PRINT fullname$ + ".GED :"; TAB(40); USING " ###"; prg(1); prg(2); prg(3); prg(4)
			PRINT
			PRINT "REMA5.FAC :"; TAB(40); USING " ###"; pr(1); pr(2); pr(3); pr(4)
			PRINT
			PRINT "Press any key to abort program"
			sss$ = INPUT$(1)
			GOTO ex
		 END IF
	NEXT i
	geoldata = -1
RETURN

searchgd:
	ngedrec = LOF(10) \ 64
	FOR ir = 2 TO ngedrec
		GET #10, ir, geol
		namg$ = UCASE$(geol.nam)
		namg$ = UCASE$(RTRIM$(namg$))
		m = INSTR(namk$, namg$)
		IF m > 0 THEN
			EXIT FOR
		END IF
	NEXT ir
	wwl = CSRLIN
	LOCATE 1, 52
	IF ir = ngedrec + 1 THEN
		PRINT "## Record not found !";
		GOSUB bbb
		findfl = 1
		LOCATE wwl, 1
	ELSE
		PRINT "--> Record found";
		LOCATE wwl, 1
		IRHOA = 0: : IRHO = 0: IMU = 0: ITAUA = 0: ITAU = 0: ISIG = 0: tec$ = "N"

		the = VAL(geol.azim)              'retrieving the tectonic parameters
		THE0 = the
		IPFI = the: IPFIA = the                '--------------
		PSI = VAL(geol.plun)
		PSI0 = PSI
		IPSI = PSI: IPSIA = PSI                '---------------

		bfs(1, 1) = geol.bfs11
		bfs(2, 1) = geol.bfs21
		rho(1) = VAL(geol.dfoli1)
		amu(1) = VAL(geol.ifoli1)
		tau(1) = VAL(geol.dline1)
		sig(1) = VAL(geol.iline1)
		IF bfs(1, 1) = "B" THEN
			IRHO = rho(1): IRHOA = rho(1)          '--------------
			IMU = amu(1)
			ITAU = tau(1): ITAUA = tau(1)
			ISIG = sig(1)
			tec$ = "Y"
		END IF

		bfs(1, 2) = geol.bfs12
		bfs(1, 2) = UCASE$(bfs(1, 2))
		bfs(2, 2) = geol.bfs22
		rho(2) = VAL(geol.dfoli2)
		amu(2) = VAL(geol.ifoli2)
		tau(2) = VAL(geol.dline2)
		sig(2) = VAL(geol.iline2)
		IF bfs(1, 2) = "B" THEN
			IRHO = rho(2): IRHOA = rho(2)          '--------------
			IMU = amu(2)
			ITAU = tau(2): ITAUA = tau(2)
			ISIG = sig(2)
			tec$ = "Y"
		END IF

	GOSUB coran
	END IF
CASE 3
		 nonor = -1
		 tec$ = "N"
END SELECT
RETURN


bbb: BEEP: SLEEP 1: BEEP: SLEEP 1: BEEP: RETURN

ex:                              ' termination
FOR ii = 1 TO 10
	KEY ii, " ": KEY(ii) OFF
NEXT ii
KEY OFF
VIEW PRINT 1 TO 25
COLOR 7, 0
CLOSE
END
RETURN

coran:
 IF nonor THEN RETURN
 IPFI = IPFI + (IP1 - IP3) * 30
 IPFI = IPFI - (IP1 - 6) * 30
 IF IP2 = 90 THEN IPSI = 90 - IPSI
 F3 = (IP1 - 6) * 30
 F1 = IPFI / DEG: F2 = IPSI / DEG: F3 = F3 / DEG
 IRHO = IRHOA
 IRHO = IRHO + IP4
 IF IRHO >= 360 THEN IRHO = IRHO - 360
 IF ITAUA + ISIG = 0 AND tec$ = "Y" THEN
	 w = IRHO + 270                                ' fictive lineation
	 ITAU = w MOD 360
	 ISIG = 0
 END IF
RETURN

receive:                    '  wait for response a$  with timeout
timeout = 5
star1 = TIMER
a$ = ""
DO
		IF LOC(1) > 0 THEN
			a1$ = INPUT$(1, #1)
			a$ = a$ + a1$
			IF a1$ = CHR$(10) THEN EXIT DO
		END IF
	wt = TIMER - star1
	IF wt > timeout THEN
	  CLS 2
	  LOCATE 1, 1
	  IF barva THEN COLOR 13 ELSE COLOR 15
	  PRINT "No message received"
	  PRINT "F A T A L  E R R O R ";
	  COLOR 7
	  GOSUB bbb

	  CLOSE
	  LOCATE 1, 55: PRINT "< CR > abort program";
	  aaxaa$ = INPUT$(1)
	  END

	END IF
LOOP WHILE -1
'a$ = LEFT$(a$, LEN(a$) - 2)
RETURN

DEFINT I-N
'***************************************************************************
'
		 SUB Clearbuff
'
'           Purpose
'              Clearing input buffer of the serial chanell.
'              It is considered to be finished if in the last
'              0.1 s has not come any byte.
'
'***************************************************************************
start = TIMER
DO
	IF LOC(1) > 0 THEN
		ww$ = INPUT$(LOC(1), #1)
		start = TIMER
	END IF
	wt = TIMER - start
LOOP UNTIL LOC(1) = 0 AND wt > .1
END SUB

